import java.util.ArrayList;
import java.util.Random;

//string to
public class Field {
    private  int m;
    private  int n;
    private ArrayList<Police> polices = new ArrayList<Police>();
    private Robber Robber;
    public String[][] fieldShape;

    public Field(int m, int n) {
        this.m = m;
        this.n = n;
        fieldShape = new String[m][n];
        for (int i = 0; i < m; i++)
            for (int j = 0; j < n; j++)
                fieldShape[i][j] = "-";
    }

    public int getM() {
        return m;
    }

    public void setM(int m) {
        this.m = m;
    }

    public int getN() {
        return n;
    }

    public void setN(int n) {
        this.n = n;
    }

    public void setFirstPlaceOfPolice(int policeNum) {
        int tmpX, tmpY, cnt = 0;
        Random randomGenerator = new Random();
        for (int i = 0; i < policeNum; i++) {
            tmpX = randomGenerator.nextInt(m);
            tmpY = randomGenerator.nextInt(n);
            if (polices.size() == 0) {
                Police p = new Police(tmpX, tmpY);
                fieldShape[tmpX][tmpY] = "P";
                polices.add(p);
                System.out.println("First police created");
            } else {
                for (Police police : polices) {
                    if (police.getX() == tmpX && police.getY() == tmpY) {
                        i--;
                        cnt++;
                        break;
                    }
                }
                if (cnt == 0) {
                    Police p = new Police(tmpX, tmpY);
                    fieldShape[tmpX][tmpY] = "P";
                    polices.add(p);
                }
            }
        }
    }

    public void setFirstPlaceOfRobber() {
        int tmpX, tmpY, cnt = 0;

        while (true) {
            Random randomGenerator = new Random();
            tmpX = randomGenerator.nextInt(m);
            tmpY = randomGenerator.nextInt(n);
            for (Police police : polices) {
                if (police.getX() == tmpX && police.getY() == tmpY) {
                    cnt++;
                    break;
                }
            }
            if (cnt == 0) {
                Robber Robber = new Robber();
                fieldShape[tmpX][tmpY] = "-";
                return;
            }
        }
    }

    public void changeField() {
        for (int i = 0; i < m; i++)
            for (int j = 0; j < n; j++)
                fieldShape[i][j] = "-";

        fieldShape[Robber.getX()][Robber.getY()] = "D";
        boolean b = false;
        for (Police police : polices) {

            if (fieldShape[police.getX()][police.getY()].equals("D")) {
                b = true;
                fieldShape[police.getX()][police.getY()] = "*";

            }
            if (fieldShape[police.getPreviosX()][police.getPreviosY()].equals("D")) {
                b = true;
                fieldShape[police.getX()][police.getY()] = "*";

            }
            if (!fieldShape[police.getX()][police.getY()].equals("*"))
                fieldShape[police.getX()][police.getY()] = "P";
        }
        if (b == true) {
            //show field
            System.exit(0);
        }
    }


}
